#ifndef CONF_H
#define CONF_H DONE

int db_set_rebuild_rules(void);

char *get_fts_dir(void);
int conf_isat(char *at);
int conf_isat_hour(char *at);
void config_set(int x, char *s);
char *file_fts(char *s);

int time_match(int t, char *at);
int conf_setpass(void);
char *conf_getpass(void);
void config_load(void);
int config_true(int x);
char *config_get(int x);
char *config_getu(int x);
char *file_config(char *s);
char *file_hist(char *s);
char *file_work(char *s);
char *file_log(char *s);
int conf_item_max(void);

enum {C_EXPIRE_AT
	,C_MYNAME,C_CONFIG,C_HISTORY,C_SPOOL
	,C_LOGLVL,C_WORKAREA,C_LOGDIR,C_DEBUG,C_LIFE,C_MANAGER,C_MODE
	,C_MAIL,C_SENDMAIL,C_FROM,C_EXPIRE_CHUNK,C_CONFIRM
	,C_WORKAREA_MIN,C_HISTORY_MIN,C_SPOOL_MIN,C_DF
	,C_REPORT,C_DISKSPACE,C_TOO_OLD,C_TIMEZONE,C_NODNS,C_PORT
	,C_NNTP_USER,C_NNTP_PASS,C_LOGUSE,C_CACHEDONLY,C_DEBUG_STORE
	,C_FEED_READER,C_DEBUG_ROTATE,C_MEMDEBUG,C_LOGDIR_MIN,C_CACHEDALL
	,C_TIMEOUT,C_HEAD_CACHE,C_HEAD_LIMIT,C_ACTIVE_STATIC,C_POSTONLY	,C_ITEM_MAX, C_LIST_MIN, C_OPEN_RETRY, C_DB_MAX, C_NNTP_BIGREJECT
	,C_NOSTREAM,C_NNTP_SLOW,C_RESELL_MAIL,C_RESELL_ADDRESS1,C_RESELL_ADDRESS2
	,C_NNTP_BIGREJECT2,C_DB_INDEX,C_IHAVE_GUESS,C_DB_QIO,C_UPGRADE
	,C_DIRFAST, C_NNTP_ZERO, C_OPEN_BLOCK, C_NNTP_XPOSTING
	,C_UPDATE_GROUPS1, C_UPDATE_GROUPS2, C_UPDATE_GROUPS3 
	,C_NOSPACECHECK,C_NNTP_LOGOFF,C_NWSERVER,C_CHAN_NOBUFF
	,C_SEND_AT,C_SEND_LATER,C_LIST_READONLY,C_NOADVERT
	,C_SUCK_BATCHN,C_SUCK_BATCHSIZE,C_CANCEL_ANYONE,C_CANCEL_USERS
	,C_MAX_SPEED, C_NNTP_ANYBLOCK, C_REPLICATE
	,C_EXPIRE_FAST,C_EXPIRE_MINUTES,C_HIDE_QUEUE, C_SUCK_REQUEUE, C_GROUPS_AT
	,C_XOVER_CACHE,C_BODY_CHUNK,C_SUCK_TIMEOUT
	,C_EXPIRE_BITS, C_NO_NEWNEWS, C_AUTH_CASE
	,C_NNTP_BLOCK,C_FTS_DIR,C_FTS_EXPIRE, C_EXPIRE_SMALL, C_NOCONTROL
	,C_SUCK_STREAM, C_EXPIRE_DELAY, C_MAIL_FROM
	,C_LOG_AGAIN,C_LOG_NNTP,C_LOG_INLINE,C_POST_ROUTE
	,C_PIDENT, C_MAX_OUT, C_ORG_REPLACE, C_ORG, C_OUT_SIZE
	,C_POST_LOG, C_SUCK_UUCP, C_UUCP_CRLF, C_TCP_NODELAY
	,C_IN_SIZE, C_STR_START, C_DB_FLUSH_EVERY, C_DB_FLUSH_N
	,C_ATEXIT_DISABLE,C_DB_RAW_CACHE,C_PGP
	,C_SPOOL2,C_SPOOL3,C_SPOOL4,C_SPOOL5,C_SPOOL6,C_SPOOL7,C_SPOOL8
	,C_DISKSPACE2,C_DISKSPACE3,C_DISKSPACE4,C_DISKSPACE5,C_DISKSPACE6,C_DISKSPACE7,C_DISKSPACE8
	,C_XOVER_EXTRA1,C_XOVER_EXTRA2, C_EXPIRE_MIN, C_XOVER_ONDEMAND
	,C_SPOOL_FREE, C_BUCKET_SIZE, C_SORT_CHUNK
	,C_DEBUG_ROTATE_IN, C_DEBUG_ROTATE_OUT, C_STAMP_PATH
	,C_AUTOEXPIRE , C_DF_COLUMN
	,C_BIG_SIZE, C_INDEX_BLOCKS, C_DB_INDEX_CACHE, C_DB_DIR_CACHE
	,C_LIVE_NOSTREAM, C_NT_DOMAIN, C_EXPIRE_ANY, C_XOVER_DIR
	,C_MCACHE_DISABLE, C_SUCK_MAXOLD, C_NON_ASCII
	,C_LOG_IHAVE,C_SLAVE_PORTS,C_SLAVE_N,C_SLAVE_FEED
	,C_ACCESS_TWICE,C_POST_NOSUCK,C_SUCK_DISABLE
	,C_CONVERT_ADD,C_INN_BUG,C_SLAVE_RESTART
	,C_REBUILD_FASTER,C_CONVERT_FEED,C_FEED_ALLOW
	,C_IHAVE_NOCLOSE,C_AUTODIAL, C_PGPPATH
	,C_CACHE_ONXOVER, C_SUCK_MAXGROUPS,C_USER_SINGLE
	,C_STRIP_AUTH,C_STRIP_POSTING_HOST,C_POST_REC
	,C_AUTH_DLL,C_GROUP_DLL,C_UUCP_BINARY,C_CONFIRM_BODY
	,C_NEWNEWS_USERS,C_XOVER_MOVED, C_BIND_IN, C_BIND_OUT
	,C_NOFLUSHRETRY,C_STRIP_PATH, C_REJECT_ADDHIST
	,C_DEBUG_MEM,C_INDEX_MAP,C_INDEX_BUFFER,C_TIMING
	,C_RAS_LIST,C_RAS_NUMBER,C_RAS_USERNAME,C_RAS_PASSWORD
	,C_RAS_ENTRY,C_RAS_DOMAIN, C_LIVE_STREAM
	,C_EMPTY_ONGROUP,C_FEED_BUG,C_LIVE_TIMEOUT,C_IHAVE_BUG
	,C_SPAM_STOP,C_SPAM_TEST,C_SPAM_KEEPN
	,C_SPAM_DUP_TOTAL,C_SPAM_DUP_CROSS
	,C_SPAM_DUP_HITS,C_SPAM_FROM_CROSS
	,C_SPAM_FROM_HITS,C_SPAM_HOST,C_SPAM_FROM_TOTAL	
	,C_NNTP_SUCK1
	,C_NNTP_SUCK2 ,C_NNTP_SUCK3 ,C_NNTP_SUCK4
	,C_NNTP_SUCK5 ,C_NNTP_SUCK6 ,C_NNTP_SUCK7
	,C_NNTP_SUCK8 ,C_NNTP_SUCK9 ,C_NNTP_SUCK10
	,C_NNTP_SUCK11 ,C_NNTP_SUCK12 ,C_NNTP_SUCK13
	,C_NNTP_SUCK14 ,C_NNTP_SUCK15 ,C_NNTP_SUCK16
	,C_NNTP_SUCK17 ,C_NNTP_SUCK18 ,C_NNTP_SUCK19
	,C_NNTP_SUCK20
	,C_NNTP_SUCK21 ,C_NNTP_SUCK22 ,C_NNTP_SUCK23
	,C_NNTP_SUCK24 ,C_NNTP_SUCK25 ,C_NNTP_SUCK26
	,C_NNTP_SUCK27 ,C_NNTP_SUCK28 ,C_NNTP_SUCK29
	,C_NNTP_SUCK30
	,C_UPDATE_AT
	,C_UPDATE_AT2,C_UPDATE_AT3,C_UPDATE_AT4
	,C_UPDATE_AT5,C_UPDATE_AT6,C_UPDATE_AT7
	,C_UPDATE_AT8,C_UPDATE_AT9,C_UPDATE_AT10
	,C_UPDATE_AT11,C_UPDATE_AT12,C_UPDATE_AT13
	,C_UPDATE_AT14,C_UPDATE_AT15,C_UPDATE_AT16
	,C_UPDATE_AT17,C_UPDATE_AT18,C_UPDATE_AT19
	,C_UPDATE_AT20
	,C_UPDATE_AT21,C_UPDATE_AT22,C_UPDATE_AT23
	,C_UPDATE_AT24,C_UPDATE_AT25,C_UPDATE_AT26
	,C_UPDATE_AT27,C_UPDATE_AT28,C_UPDATE_AT29
	,C_UPDATE_AT30
	,C_SPOOL_HASH,C_XOVER_HASH
 	,C_FEED_TESTING,C_NIDXBF,C_IHAVE_TIMEOUT
 	,C_GROUP_SETEND, C_ALLOW_WORLD,C_CONTROL_ME
	,C_SUCK_PERCENT,C_XOVER_DISABLE,C_XHDR_DISABLE
	,C_TCP_WRAPLF,C_CANCEL_STORE,C_SORT_LASTMB
	,C_SORT_FREQ,C_LOG_SYSTEM,C_LOG_FILES,C_SORT_SIZE
	,C_HIST_DEBUG, C_UUCP_SIMPLE, C_DONT_SLEEP
	,C_IHAVE_ACCESS,C_SPAM_NOHOST_REJECT,C_AUTH_NOGROUP
	,C_AUTH_NETSCAPE,C_CHAN_LOGALL
	,C_TAKETHIS_FAIL,C_CACHE_ONGROUP,C_STRINGS_STATIC
	,C_ME_CONTINUE,C_LIVE_SPOOL_SLOW
	,C_SPAM_DEBUG,C_MODERATED_NOCHECK
	,C_SUCK_CLOSE,C_AUTH_SHOWPROT,C_AUTH_NS4
	,C_POST_ADDHEAD1,C_POST_ADDHEAD2,C_POST_ADDHEAD3
	,C_AUTH_GROUPFILE,C_READONLY_ID,C_READONLY_N
	,C_DMGRSVC_PORT,C_ANON_POSTING_HOST,C_ITEM_ADD, C_SPAM_LOCALONLY
	,C_CANCEL_DISABLE, C_APPROVED_MANUAL, C_CONCURRENT_LIMIT
	,C_SPAM_LINES,C_SPAM_ALLOWHOSTS,C_SPAM_ALLOWIHAVE
	,C_MAIL_BOUNCE,C_AUTH_EXTERN,C_AUTH_NOSYSTEM
	,C_AUTH_LIB,C_DMGRSVC_DEBUG,C_DMGRCGI_DEBUG
	,C_DB_SPLIT,C_AUTH_POPHOST,C_DB_SPLIT_SIZE
	,C_POST_NOTRACE, C_UUCP_UNCACHED, C_CHECKGROUPS_EMAIL
	,C_ACCESS_FORWARD,C_ACCESS_FORWARD_ALL
	,C_INDEX_NBUFFER,C_BUCKET_NOFILL,C_HIDE_REGISTER
	,C_REJECT_EMPTY,C_APPROVED_AUTO 
	,C_HISTORY_CHUNK,C_MAX_GROUPS
	,C_AUTH_VIRTUAL_IP,C_AUTH_VIRTUAL_USER
	,C_XOVER_WRITE_CACHE, C_RETRY_441
	,C_XREF_ALWAYS,C_INPATHS
	,C_CANCEL_REJECT,C_CANCEL_REJECT_AFTER
	,C_BUCKET_ITEMS
	,C_LOG_ROTATE_NOSTART
	,C_SUCK_LATER,C_USE_SMTP
	,C_DB_GET_BUG
	,C_AUTH_STRIP_DOMAIN
	,C_IDENT_TIMEOUT
	,C_LOG_OUT_ONLY
	,C_MAX_OUT_TOTAL
	,C_BUCKET_FILL
	,C_EXPIRE_QUANTA
	,C_AUTH_POPCACHE
	,C_NOCACHED_SUBJECT
	,C_SUCK_FILE1
	,C_SUCK_FILE2
	,C_SUCK_FILE3
	,C_SUCK_FILE4
	,C_GUP_TO
	,C_GUP_AT
	,C_GUP_MASK
	,C_GUP_ADD
	,C_GUP_SITE	
	,C_TIMEZONE_POST
	,C_LOG_ONEFILE
	,C_LOG_NO_IN
	,C_LOG_NO_OUT
	,C_SPAM_ALLOWGROUPS
	,C_POSTING_HOST_NUMBER
	,C_HISTORY_MOVED
	,C_FEED_NRETRY
	,C_LIVE_DELAY
	,C_HEADER_GROUPS
	,C_HEADER_CHAN_N
	,C_HEADER_EXPIRE
	,C_HEADER_BODY_MB
	,C_HEADER_PATH
	,C_HEADER_HOST
	,C_SPAM_NPOST
	,C_HEADER_PREFETCH
	,C_HEADER_TIMEOUT
	,C_SUCK_UUCP_FASTER
	,C_LOG_IGNORE
	,C_CACHE_ONNEWNEWS
	,C_SHOWUSERS_BYUSER
	,C_POST_IGNOREDUP
	,C_DB_SORT_PILES
	,C_DB_SORT
	,C_PURGE_SEEK
	,C_AUTH_LOGIN_MAX
	,C_SPOOL9,C_SPOOL10
	,C_SPOOL11,C_SPOOL12,C_SPOOL13,C_SPOOL14,C_SPOOL15
	,C_SPOOL16,C_SPOOL17,C_SPOOL18,C_SPOOL19,C_SPOOL20
	,C_SPOOL21,C_SPOOL22,C_SPOOL23,C_SPOOL24,C_SPOOL25
	,C_SPOOL26,C_SPOOL27,C_SPOOL28,C_SPOOL29,C_SPOOL30
	,C_DISKSPACE9,C_DISKSPACE10
	,C_DISKSPACE11,C_DISKSPACE12,C_DISKSPACE13,C_DISKSPACE14,C_DISKSPACE15
	,C_DISKSPACE16,C_DISKSPACE17,C_DISKSPACE18,C_DISKSPACE19,C_DISKSPACE20	
	,C_DISKSPACE21,C_DISKSPACE22,C_DISKSPACE23,C_DISKSPACE24,C_DISKSPACE25
	,C_DISKSPACE26,C_DISKSPACE27,C_DISKSPACE28,C_DISKSPACE29,C_DISKSPACE30	
	,C_GROUPS_AT2,C_GROUPS_AT3,C_GROUPS_AT4,C_GROUPS_AT5
	,C_AUTH_SPAWN, C_REPORT_OLD
	,C_RAS_MAXCALLS
	,C_CONFIRM_SUCCESS
	,C_GSTAT
	,C_LOG_IO
	,C_ACTIVE_REQUIRE
	,C_CHECK_SECOND
	,C_POST_SUPERSEDES
	,C_POST_SENDSYS
	,C_POST_VERSION
	,C_POST_CANCEL
	,C_POST_APPROVED
	,C_POST_NEWGROUP
	,C_POST_RMGROUP
	,C_POST_NO_ORIGINAL_HOST
	,C_POST_NONGROUPS
	,C_PATH_POST
	,C_CONTROL_RULES_ONLY
	,C_INDEX_DEBUG
	,C_NT_USER_BATCH
	,C_GETGROUPS_UNDELETE
	,C_AUTH_DBFILE 
	,C_HEADER_EXPIRE_CAREFUL
	,C_MULTICAST_LIST
	,C_LOG_NODAILY
	,C_CACHED_HIDE
	,C_USER_CACHE
	,C_FILTER_CMD
	,C_NOCEM 
	,C_NOCEM_SKIPPGP
	,C_SEND_AT_SITE1
	,C_SEND_AT_SITE2
	,C_SEND_AT_SITE3
	,C_SEND_AT_SITE4
	,C_SEND_AT_SITE5
	,C_SEND_AT_SITE6
	,C_SEND_AT_SITE7
	,C_SEND_AT_SITE8
	,C_SEND_AT_SITE9
	,C_HEADER_BODY_N
	,C_PILE_SEPARATE	
	,C_SUCK_UUCP_GROUPS
	,C_NOCEM_GROUPS
	,C_USER_CACHE_CLEAR
	,C_XOVER_EXPIRE_FAST
	,C_UUCP_SEND_MOD
	,C_SUPER_IGNORE
	,C_SUCK_CHECK_AGE
	,C_HIST_NEVER
	,C_NULL_NOSTRIP
	,C_NNTP_WRITE_FAST
	,C_XOVER_DAYS
	,C_FULLSTOP_FIX
	,C_FEED_NOMASK
	,C_RING_SIZE
	,C_NEXT_BUG
	,C_PATH_REMOVE
	,C_LOG_COUNT
	,C_STRIP_AUTH_POST
        ,C_SPAWN_EXPIRE
	,C_APPROVE_AUTHORIZED
	,C_NO_QUEUE
	,C_WELCOME
	,C_BIG_NGROW
	,C_POST_ADDHEAD4
	,C_POST_ADDHEAD5
	,C_SLAVE_ROUTE
	,C_POST_FROM
	,C_STAT_BUG
	,C_FUTURE_OK
	,C_REMOVE_ALL_LOST
	,C_SPAM_POST_LOCAL_OK
	,C_AUTH_SPAWN_IP
	,C_HDR_REMOVE
	,C_DFEED_DEBUG
	,C_AUTH_RADIUS_HOST
	,C_AUTH_RADIUS_SECRET
	,C_AUTH_RADIUS_ATTRIBUTE
	,C_LOG_ACCEPT
	,C_HISTORY_SYSOPEN
	,C_AUTH_MESSAGE
	,C_AUTH_MESSAGE_GROUP
	,C_STRIP_ALLPATHS
	,C_DNS_CHECK
	,C_POST_QUOTED_LIMIT
	,C_POST_QUOTED_MESSAGE
	,C_SPAM_REJ_SIZE
	,C_DATE_DAY
	,C_GROUPS_AT6,C_GROUPS_AT7,C_GROUPS_AT8,C_GROUPS_AT9
	,C_GROUPS_AT10
	,C_GROUPS_AT11
	,C_GROUPS_AT12
	,C_GROUPS_AT13
	,C_GROUPS_AT14
	,C_GROUPS_AT15
	,C_GROUPS_AT16
	,C_GROUPS_AT17
	,C_GROUPS_AT18
	,C_GROUPS_AT19
	,C_GROUPS_AT20
	,C_GROUPS_AT21
	,C_GROUPS_AT22
	,C_GROUPS_AT23
	,C_GROUPS_AT24
	,C_GROUPS_AT25
	,C_GROUPS_AT26
	,C_GROUPS_AT27
	,C_GROUPS_AT28
	,C_GROUPS_AT29
	,C_NEWGROUP_AUTO,C_AUTH_WILD
	,C_PAM_TYPE
	,C_POST_QUOTED_MIN
	,C_IHAVE_CHAN_TIMEOUT
	,C_BUCKETS_SORT
	,C_SOCKET_NOINHERIT
	,C_DUDP_CMD
	,C_PULL1,C_PULL2,C_PULL3,C_PULL4,C_PULL5
	,C_PULL6,C_PULL7,C_PULL8,C_PULL9,C_PULL10
	,C_PULL11,C_PULL12,C_PULL13,C_PULL14,C_PULL15
	,C_PULL16,C_PULL17,C_PULL18,C_PULL19,C_PULL20
	,C_PULL
	,C_SPAM_NOREPORT
	,C_XOVER_NOIDLE
	,C_HEADER_NO_LISTGROUP
	,C_HEADER_NO_EXPIRE
	,C_XOVER_CACHE_DISABLE
	,C_XOVER_SEEK_DISABLE
	,C_XOVER_SPREAD
	,C_MAX_ITEMS
	,C_AUTH_SPACES
	,C_ML_DISABLE
	,C_AUTH_READART
	,C_SPAM_SUBJECT_HITS
	,C_NT_USER_NETWORK
	,C_POST_FROM_ADDUSER
	,C_POST_FORCE_DATE
	,C_POST_OFFSET
	,C_CANCEL_ME
	,C_PGPTZ
	,C_LINES_ADD
	,C_SLAVE_BYFILE
	,C_LOG_REJ
	,C_TOMAIL_FROM
	,C_REINDEX_STACK
	,C_GETMAIL_FROM
	,C_GETMAIL_AT
	,C_TOMAIL_USER_BYTES
	,C_TOMAIL_USER_ITEMS
	,C_TOMAIL_MAX_SIZE
	,C_TOMAIL
	,C_PART_DIR
	,C_PART_DIR2
	,C_PART_DIR3
	,C_PART_DIR4
	,C_PART_DIR5
	,C_PART_DIR6
	,C_PART_BUCKETS
	,C_DMGRSVC_ACCESS
	,C_SUCK_MAXLOG
	,C_DNEWS_TESTING
	,C_SPAM_NPOST_MAX
	,C_COMPRESS_DISABLE
	,C_POST_PROT_MSG
	,C_REBUILD_CANCEL
	,C_RAS_SLEEP
	,C_SENDBF_GROW
	,C_FIX_RE
	,C_PART_INDEX
	,C_TCP_RCVBF
	,C_SHOW_ALL_OUTPUT
	,C_REPORT_BUCKETS
	,C_DISKIO_MIN
	,C_SUCK_NOAUTH1
	,C_SUCK_NOAUTH2
	,C_RULES_DEBUG
	,C_LISTEN_PORTS
	,C_LIMIT_USERS
	,C_THREAD_IN
	,C_PART_FAST
	,C_THREAD_WRITE
	,C_FILTER_SILENT
	,C_SPAM_REPORT_BRIEF
	,C_THREAD_FIX
	,C_AUTH_FRIENDLY
	,C_NAKED_ALLOW
	,C_NAKED_REMOVE
	,C_TOMAIL_STRIP_BODY
	,C_PASS_NOLIMIT
	,C_CANCEL_VERIFY_HOST
	,C_PASS_TIMEOUT
	,C_UUCP_NOFLUSH
	,C_PGP_OPTIONS
	,C_TEST_NULLS
	,C_THREAD_FAKE
	,C_INPUT_WINDOW
	,C_THREAD_TIMEOUT
	,C_LISTEN_EXTRA
	,C_MASTER_ADDRESS
	,C_SPAWN_PROG
	,C_SPAM_AGE
	,C_GROUP_NEW
	,C_GETMAIL_CROSSPOSTS
	,C_STARTUP_DELAY
	,C_POST_ADD_GROUP
	,C_AUTH_SPAWN_LIMITS
	,C_USER_BLANK_OK
	,C_THREAD_TIMEOUT_WAIT
	,C_POST_PROT_PINE
	,C_INDEX_CHANGES
	,C_SPONSER_URL
	,C_SPONSER_DISABLE
	,C_SPONSER_ENABLE
	,C_CANCEL_RELEASE
	,C_XOVER_EXPIRE_NORMAL
	,C_SET_WORKINGSET
	,C_POST_ADD
	,C_HANGING_FAST
	,C_EXPIRE_LOST_BUCKETS
	,C_LOG_EVERYTHING
	,C_USE_CLOCK
	,C_USER_SLOW
	,C_READ_MID_OK
	,C_POST_CANCEL_AUTHORIZED
	,C_HIDE_VERSION
	,C_THREAD_REUSE
	,C_REAL_MAX
	,C_AUTHINFO_STRICT
	,C_DONT_DUP
	,C_SPAWN_FILTER_MAX
	,C_HEADER_NEWNUMBERS
	,C_DETECT_SUCK
	,C_TOMAIL_SUBJECT_ADD
	,C_AUTH_USERDOMAIN
	,C_AUTH_LOCAL_TOO
	,C_AUTH_POP_DOMAINS
	,C_SPONSER_NICER
	,C_POST_ADD_BLOCK
	,C_PIPE_USE
	,C_LIMIT_IP
	,C_WIDEAREA_HOST
	,C_WIDEAREA_MYNAME
	,C_POST_SPAWN
	,C_SPONSOR_DISABLE
	,C_SPAM_IGNORE_PARTS
	,C_WIDEAREA_MAX
	,C_HISTORY_PAGE_SIZE
	,C_FILTER_SYNC
	,C_DMGRCGI_ACCESS_STRICT
	,C_BUCKET_SORT_MAX
	,C_TOMAIL_ROUTE
	,C_POST_CANCEL_OWNER
	,C_FIX_PROTECTION_DISABLE
	,C_TELLNEWS_PASS_MASK
	,C_POISON_GROUP
	,C_POST_LOG_SIZE
	,C_ARTICLE_430
	,C_DEBUG_THOUT
	,C_AUTH_VIRTUAL_LOGIN
	,C_AUTH_MASK
	,C_TOMAIL_RUN
	,C_PRIORITY_BOOST
	,C_LIMIT_CONNECTOK
	,C_STRIP_POSTING_HOST_AUTH
	,C_RADIUS_VENDOR_ENCODED
	,C_RULES_LOCAL_ONLY
	,C_RADIUS_ACCT
	,C_POSTONLY_IHAVE
	,C_RADIUS_ACCT_PORT
	,C_AUTH_SKIP_CACHE
	,C_TOMAIL_URL
	,C_TOMAIL_PROJECT
	,C_GETMAIL_STRIP
	,C_ACCESS_POST_WARN
	,C_TOMAIL_WEB_LINK
	,C_SPAM_USER_NPOST_MAX
	,C_SET_DTABLE
	,C_XOVER_XHASH
	,C_TOMAIL_FROM_FORMAT
	,C_GETMAIL_FAIL_KEEPN
	,C_POST_STRIP
	,C_LOG_USERS
	,C_HIST_MAX
	,C_TOMAIL_REPLY_FORMAT
	,C_XTRACE_IPNAME
	,C_SUCK_NOFIX
	,C_HIDE_KEY
	,C_GMT_FIX
	,C_INDEX_MIN
	,C_AUTH_TIMEOUT
	,C_DMULTI_SLAVE_ONLY
	,C_SMALL_FAST
	,C_SMALL_SPEED
	,C_IDX_WRITE_CACHE
	,C_IDX_WRITE_SIZE
	,C_TOMAIL_NNTP_LINK
	,C_PART_THREAD
	,C_PILE_NOPEN
	,C_FIXMOD_DISABLE
	,C_DFILTER_BINARY_LINES
	,C_SKIP_DUP
	,C_WIDEAREA_IPCHECK
	,C_WIDEAREA_TIMEOUT
	,C_SETPASS_DISABLE
	,C_PART_VANISH
	,C_PART_VANISH_MAX
	,C_TOMAIL_FROM_USER
	,C_POST_REC_NONEWSGROUPS
	,C_SLAVE_SAME
	,C_KILL_LOST_DISABLE
	,C_JUST_DIE
	,C_RADIUS_BIND_OUT
	,C_ACCESS_APPLYIP
	,C_SUCK_NOSKIP
	,C_CONTROL_STORE
	,C_PART_QUESIZE
	,C_GETMAIL_HEADER
	,C_POSTING_HOST_HIDE
	,C_AUTH_SPAWN_ADDIP
};
	     

#ifdef ISCONF
static char *conf_name[]={ 
	"EXPIRE_AT"
	,"MYNAME","CONFIG"
	,"HISTORY","SPOOL","LOGLVL","WORKAREA","LOGDIR","DEBUG","LIFE"
	,"MANAGER","MODE","MAIL","SENDMAIL","FROM","EXPIRE_CHUNK"
	,"CONFIRM","WORKAREA_MIN","HISTORY_MIN","SPOOL_MIN","DF"
	,"REPORT","DISKSPACE", "TOO_OLD", "TIMEZONE", "NODNS", "PORT"
	,"NNTP_USER","NNTP_PASS", "LOGUSE","CACHEDONLY","DEBUG_STORE"
	,"FEED_READER", "DEBUG_ROTATE", "MEMDEBUG", "LOGDIR_MIN"
	,"CACHEDALL","TIMEOUT", "HEAD_CACHE", "HEAD_LIMIT", "ACTIVE_STATIC"
	,"POSTONLY", "ITEM_MAX", "LIST_MIN", "OPEN_RETRY"
	,"DB_MAX", "NNTP_BIGREJECT",  "NOSTREAM", "NNTP_SLOW"
	,"RESELL_MAIL",  "RESELL_ADDRESS1", "RESELL_ADDRESS2"
	,"NNTP_BIGREJECT2", "DB_INDEX", "IHAVE_GUESS", "DB_QIO"
	,"UPGRADE", "DIRFAST", "NNTP_ZERO", "OPEN_BLOCK", "NNTP_XPOSTING"
	,"UPDATE_GROUPS1", "UPDATE_GROUPS2", "UPDATE_GROUPS3" 
	,"NOSPACECHECK","NNTP_LOGOFF", "NWSERVER", "CHAN_NOBUFF"
	,"SEND_AT","SEND_LATER", "LIST_READONLY", "NOADVERT"
	,"SUCK_BATCHN","SUCK_BATCHSIZE","CANCEL_ANYONE","CANCEL_USERS"
	,"MAX_SPEED", "NNTP_ANYBLOCK", "REPLICATE"
	,"EXPIRE_FAST","EXPIRE_MINUTES", "HIDE_QUEUE", "SUCK_REQUEUE", "GROUPS_AT"
	,"XOVER_CACHE","BODY_CHUNK","SUCK_TIMEOUT"
	,"EXPIRE_BITS", "NO_NEWNEWS", "AUTH_CASE"
	,"NNTP_BLOCK", "FTS_DIR", "FTS_EXPIRE", "EXPIRE_SMALL"
	,"NOCONTROL", "SUCK_STREAM", "EXPIRE_DELAY", "MAIL_FROM"
	,"LOG_AGAIN","LOG_NNTP","LOG_INLINE","POST_ROUTE"
	,"PIDENT", "MAX_OUT", "ORG_REPLACE", "ORG", "OUT_SIZE"
	,"POST_LOG", "SUCK_UUCP",  "UUCP_CRLF", "TCP_NODELAY", "IN_SIZE"
	,"STR_START", "DB_FLUSH_EVERY", "DB_FLUSH_N", "ATEXIT_DISABLE"
	,"DB_RAW_CACHE","PGP"
	,"SPOOL2","SPOOL3","SPOOL4","SPOOL5","SPOOL6","SPOOL7","SPOOL8"
	,"DISKSPACE2","DISKSPACE3","DISKSPACE4","DISKSPACE5","DISKSPACE6","DISKSPACE7","DISKSPACE8"
	,"XOVER_EXTRA1","XOVER_EXTRA2", "EXPIRE_MIN", "XOVER_ONDEMAND"
	,"SPOOL_FREE", "BUCKET_SIZE", "SORT_CHUNK"
	,"DEBUG_ROTATE_IN","DEBUG_ROTATE_OUT"
	,"PATH_STAMP", "AUTOEXPIRE", "DF_COLUMN"
	,"BIG_SIZE", "INDEX_BLOCKS", "DB_INDEX_CACHE"
	,"DB_DIR_CACHE", "LIVE_NOSTREAM" , "NT_DOMAIN"
	,"EXPIRE_ANY", "XOVER_DIR", "MCACHE_DISABLE", "SUCK_MAXOLD"
	,"NON_ASCII", "LOG_IHAVE", "SLAVE_PORTS"
	,"SLAVE_N", "SLAVE_FEED", "ACCESS_TWICE" 
	,"POST_NOSUCK", "SUCK_DISABLE", "CONVERT_ADD"
	,"INN_BUG", "SLAVE_RESTART", "REBUILD_FAST"
	,"CONVERT_FEED","FEED_ALLOW","IHAVE_NOCLOSE"
	,"AUTODIAL", "PGPPATH", "CACHE_ONXOVER"
	,"SUCK_MAXGROUPS","USER_SINGLE","STRIP_AUTH","STRIP_POSTING_HOST"
	,"POST_REC","AUTH_DLL","GROUP_DLL","UUCP_BINARY","CONFIRM_BODY"
	,"NEWNEWS_USERS","XOVER_MOVED","BIND_IN","BIND_OUT"
	,"NOFLUSHRETRY","STRIP_PATH","REJECT_ADDHIST"
	,"DEBUG_MEM", "INDEX_MAP", "INDEX_BUFFER", "TIMING"
	,"RAS_LIST","RAS_NUMBER","RAS_USERNAME","RAS_PASSWORD"
	,"RAS_ENTRY","RAS_DOMAIN","LIVE_STREAM"
	,"EMPTY_ONGROUP","FEED_BUG","LIVE_TIMEOUT","IHAVE_BUG"
	,"SPAM_STOP","SPAM_TEST","SPAM_KEEPN"
	,"SPAM_DUP_TOTAL","SPAM_DUP_CROSS"
	,"SPAM_DUP_HITS","SPAM_FROM_CROSS"
	,"SPAM_FROM_HITS","SPAM_HOST","SPAM_FROM_TOTAL"	
	,"NNTP_FEEDER"
	,"NNTP_SUCK2" ,"NNTP_SUCK3" ,"NNTP_SUCK4"
	,"NNTP_SUCK5" ,"NNTP_SUCK6" ,"NNTP_SUCK7"
	,"NNTP_SUCK8" ,"NNTP_SUCK9" ,"NNTP_SUCK10"
	,"NNTP_SUCK11" ,"NNTP_SUCK12" ,"NNTP_SUCK13"
	,"NNTP_SUCK14" ,"NNTP_SUCK15" ,"NNTP_SUCK16"
	,"NNTP_SUCK17" ,"NNTP_SUCK18" ,"NNTP_SUCK19"
	,"NNTP_SUCK20" 
	,"NNTP_SUCK21" ,"NNTP_SUCK22" ,"NNTP_SUCK23"
	,"NNTP_SUCK24" ,"NNTP_SUCK25" ,"NNTP_SUCK26"
	,"NNTP_SUCK27" ,"NNTP_SUCK28" ,"NNTP_SUCK29"
	,"NNTP_SUCK30" 
	,"UPDATE_AT"
	,"UPDATE_AT2", "UPDATE_AT3", "UPDATE_AT4" 
	,"UPDATE_AT5","UPDATE_AT6","UPDATE_AT7"
	,"UPDATE_AT8","UPDATE_AT9","UPDATE_AT10"
	,"UPDATE_AT11","UPDATE_AT12","UPDATE_AT13"
	,"UPDATE_AT14","UPDATE_AT15","UPDATE_AT16"
	,"UPDATE_AT17","UPDATE_AT18","UPDATE_AT19"
	,"UPDATE_AT20"
	,"UPDATE_AT21","UPDATE_AT22","UPDATE_AT23"
	,"UPDATE_AT24","UPDATE_AT25","UPDATE_AT26"
	,"UPDATE_AT27","UPDATE_AT28","UPDATE_AT29"
	,"UPDATE_AT30"
	,"SPOOL_HASH","XOVER_HASH"
 	,"FEED_TESTING","NIDXBF","IHAVE_TIMEOUT"
 	,"GROUP_SETEND", "ALLOW_WORLD", "CONTROL_ME"
	,"SUCK_PERCENT","XOVER_DISABLE","XHDR_DISABLE"
	,"TCP_WRAPLF","CANCEL_STORE","SORT_LASTMB"
	,"SORT_FREQ","LOG_SYSTEM","LOG_FILES","SORT_SIZE"
	,"HIST_DEBUG","UUCP_SIMPLE", "DONT_SLEEP"
	,"IHAVE_ACCESS","SPAM_NOHOST_REJECT","AUTH_NOGROUP"
	,"AUTH_NETSCAPE","CHAN_LOGALL"
	,"TAKETHIS_FAIL","CACHE_ONGROUP","STRINGS_STATIC"
	,"ME_CONTINUE","LIVE_SPOOL_SLOW"
	,"SPAM_DEBUG","MODERATED_NOCHECK"
	,"SUCK_CLOSE","AUTH_SHOWPROT","AUTH_NS4"
	,"POST_ADDHEAD1","POST_ADDHEAD2","POST_ADDHEAD3"
	,"AUTH_GROUPFILE","READONLY_ID","READONLY_N"
	,"DMGRSVC_PORT","ANON_POSTING_HOST", "ITEM_ADD"
	,"SPAM_LOCALONLY","CANCEL_DISABLE","APPROVED_MANUAL"
	,"CONCURRENT_LIMIT"
	,"SPAM_LINES","SPAM_ALLOWHOSTS","SPAM_ALLOWIHAVE"
	,"MAIL_BOUNCE","AUTH_EXTERN","AUTH_NOSYSTEM"
	,"AUTH_LIB","DMGRSVC_DEBUG","DMGRCGI_DEBUG"
	,"DB_SPLIT","AUTH_POPHOST","DB_SPLIT_SIZE"
	,"POST_NOTRACE","UUCP_UNCACHED","CHECKGROUPS_EMAIL"
	,"ACCESS_FORWARD","ACCESS_FORWARD_ALL","INDEX_NBUFFER"
	,"BUCKET_NOFILL","HIDE_REGISTER","REJECT_EMPTY"
	,"APPROVED_AUTO","HISTORY_CHUNK"
	,"MAX_GROUPS","AUTH_VIRTUAL_IP","AUTH_VIRTUAL_USER"
	,"XOVER_WRITE_CACHE","RETRY_441"
	,"XREF_ALWAYS","INPATHS"
	,"CANCEL_REJECT","CANCEL_REJECT_AFTER"
	,"BUCKET_ITEMS","LOG_ROTATE_NOSTART"
	,"SUCK_LATER", "USE_SMTP"
	,"DB_GET_BUG","AUTH_STRIP_DOMAIN"
	,"IDENT_TIMEOUT"
	,"LOG_OUT_ONLY"
	,"MAX_OUT_TOTAL"
	,"BUCKET_FILL"
	,"EXPIRE_QUANTA"
	,"AUTH_POPCACHE"
	,"NOCACHED_SUBJECT"
	,"SUCK_FILE1"
	,"SUCK_FILE2"
	,"SUCK_FILE3"
	,"SUCK_FILE4"
	,"GUP_TO"
	,"GUP_AT"
	,"GUP_MASK"
	,"GUP_ADD"
	,"GUP_SITE"
	,"TIMEZONE_POST"
	,"LOG_ONEFILE"
	,"LOG_NO_IN"
	,"LOG_NO_OUT"
	,"SPAM_ALLOWGROUPS"
	,"POSTING_HOST_NUMBER"
	,"HISTORY_MOVED"
	,"FEED_NRETRY"
	,"LIVE_DELAY"
	,"HEADER_GROUPS"
	,"HEADER_CHAN_N"
	,"HEADER_EXPIRE"
	,"HEADER_BODY_MB"
	,"HEADER_PATH"
	,"HEADER_HOST"
	,"SPAM_NPOST"
	,"HEADER_PREFETCH"
	,"HEADER_TIMEOUT"
	,"SUCK_UUCP_FASTER"
	,"LOG_IGNORE"
	,"CACHE_ONNEWNEWS"
	,"SHOWUSERS_BYUSER"
	,"POST_INGOREDUP"
	,"DB_SORT_PILES"
	,"DB_SORT"
	,"PURGE_SEEK"
	,"AUTH_LOGIN_MAX"
	,"SPOOL9","SPOOL10"
	,"SPOOL11","SPOOL12","SPOOL13","SPOOL14","SPOOL15"
	,"SPOOL16","SPOOL17","SPOOL18","SPOOL19","SPOOL20"
	,"SPOOL21","SPOOL22","SPOOL23","SPOOL24","SPOOL25"
	,"SPOOL26","SPOOL27","SPOOL28","SPOOL29","SPOOL30"
	,"DISKSPACE9","DISKSPACE10"
	,"DISKSPACE11","DISKSPACE12","DISKSPACE13","DISKSPACE14","DISKSPACE15"
	,"DISKSPACE16","DISKSPACE17","DISKSPACE18","DISKSPACE19","DISKSPACE20"
	,"DISKSPACE21","DISKSPACE22","DISKSPACE23","DISKSPACE24","DISKSPACE25"
	,"DISKSPACE26","DISKSPACE27","DISKSPACE28","DISKSPACE29","DISKSPACE30"
	,"GROUPS_AT2"
	,"GROUPS_AT3"
	,"GROUPS_AT4"
	,"GROUPS_AT5"
	,"AUTH_SPAWN"
	,"REPORT_OLD"
	,"RAS_MAXCALLS"
	,"CONFIRM_SUCCESS"
	,"GSTAT"
	,"LOG_IO"
	,"ACTIVE_REQUIRE"
	,"CHECK_SECOND"
	,"POST_SUPERSEDES"
	,"POST_SENDSYS"
	,"POST_VERSION"
	,"POST_CANCEL"
	,"POST_APPROVED"
	,"POST_NEWGROUP"
	,"POST_RMGROUP"
	,"POST_NO_ORIGINAL_HOST"
	,"POST_NONGROUPS"
	,"PATH_POST"
	,"CONTROL_RULES_ONLY"
	,"INDEX_DEBUG"
	,"NT_USER_BATCH"
	,"GETGROUPS_UNDELETE"
	,"AUTH_DBFILE"
	,"HEADER_EXPIRE_CAREFUL"
	,"MULTICAST_LIST"
	,"LOG_NODAILY"
	,"CACHED_HIDE"
	,"USER_CACHE"
	,"FILTER_CMD"
	,"NOCEM"
	,"NOCEM_SKIPPGP"
	,"SEND_AT_SITE1"
	,"SEND_AT_SITE2"
	,"SEND_AT_SITE3"
	,"SEND_AT_SITE4"
	,"SEND_AT_SITE5"
	,"SEND_AT_SITE6"
	,"SEND_AT_SITE7"
	,"SEND_AT_SITE8"
	,"SEND_AT_SITE9"
	,"HEADER_BODY_N"
	,"PILE_SEPARATE"
	,"SUCK_UUCP_GROUPS"
	,"NOCEM_GROUPS"
	,"USER_CACHE_CLEAR"
	,"XOVER_EXPIRE_FAST"
	,"UUCP_SEND_MOD"
	,"SUPER_IGNORE"
	,"SUCK_CHECK_AGE"
	,"HIST_NEVER"
	,"NULL_NOSTRIP"
	,"NNTP_WRITE_FAST"
	,"XOVER_DAYS"
	,"FULLSTOP_FIX"
	,"FEED_NOMASK"
	,"RING_SIZE"
	,"NEXT_BUG"
	,"PATH_REMOVE"
	,"LOG_COUNT"
	,"STRIP_AUTH_POST"
        ,"SPAWN_EXPIRE"
	,"APPROVE_AUTHORIZED"
	,"NO_QUEUE"
	,"WELCOME"
	,"BIG_NGROW"
	,"POST_ADDHEAD4"
	,"POST_ADDHEAD5"
	,"SLAVE_ROUTE"
	,"POST_FROM"
	,"STAT_BUG"
	,"FUTURE_OK"
	,"REMOVE_ALL_LOST"
	,"SPAM_POST_LOCAL_OK"
	,"AUTH_SPAWN_IP"
	,"HDR_REMOVE"
	,"DFEED_DEBUG"
	,"AUTH_RADIUS_HOST"
	,"AUTH_RADIUS_SECRET"
	,"AUTH_RADIUS_ATTRIBUTE"
	,"LOG_ACCEPT"
	,"HISTORY_SYSOPEN"
	,"AUTH_MESSAGE"
	,"AUTH_MESSAGE_GROUP"
	,"STRIP_ALLPATHS"
	,"DNS_CHECK"
	,"POST_QUOTED_LIMIT"
	,"POST_QUOTED_MESSAGE"
	,"SPAM_REJ_SIZE"
	,"DATE_DAY"
	,"GROUPS_AT6"
	,"GROUPS_AT7"
	,"GROUPS_AT8"
	,"GROUPS_AT9"
	,"GROUPS_AT10"
	,"GROUPS_AT11"
	,"GROUPS_AT12"
	,"GROUPS_AT13"
	,"GROUPS_AT14"
	,"GROUPS_AT15"
	,"GROUPS_AT16"
	,"GROUPS_AT17"
	,"GROUPS_AT18"
	,"GROUPS_AT19"
	,"GROUPS_AT20"
	,"GROUPS_AT21"
	,"GROUPS_AT22"
	,"GROUPS_AT23"
	,"GROUPS_AT24"
	,"GROUPS_AT25"
	,"GROUPS_AT26"
	,"GROUPS_AT27"
	,"GROUPS_AT28"
	,"GROUPS_AT29"
	,"NEWGROUP_AUTO"
	,"AUTH_WILD"
	,"PAM_TYPE"
	,"POST_QUOTED_MIN"
	,"IHAVE_CHAN_TIMEOUT"
	,"BUCKETS_SORT"
	,"SOCKET_NOINHERIT"
	,"DUDP_CMD"
	,"PULL1","PULL2","PULL3","PULL4","PULL5"
	,"PULL6","PULL7","PULL8","PULL9","PULL10"
	,"PULL11","PULL12","PULL13","PULL14","PULL15"
	,"PULL16","PULL17","PULL18","PULL19","PULL20"
	,"PULL"
	,"SPAM_NOREPORT"
	,"XOVER_NOIDLE"
	,"HEADER_NO_LISTGROUP"
	,"HEADER_NO_EXPIRE"
	,"XOVER_CACHE_DISABLE"
	,"XOVER_SEEK_DISABLE"
	,"XOVER_SPREAD"
	,"MAX_ITEMS"
	,"AUTH_SPACES"
	,"ML_DISABLE"
	,"AUTH_READART"
	,"SPAM_SUBJECT_HITS"
	,"NT_USER_NETWORK"
	,"POST_FROM_ADDUSER"
	,"POST_FORCE_DATE"
	,"POST_OFFSET"
	,"CANCEL_ME"
	,"PGPTZ"
	,"LINES_ADD"
	,"SLAVE_BYFILE"
	,"LOG_REJ"
	,"TOMAIL_FROM"
	,"REINDEX_STACK"
	,"GETMAIL_FROM"
	,"GETMAIL_AT"
	,"TOMAIL_USER_BYTES"
	,"TOMAIL_USER_ITEMS"
	,"TOMAIL_MAX_SIZE"
	,"TOMAIL"
	,"PART_DIR"
	,"PART_DIR2"
	,"PART_DIR3"
	,"PART_DIR4"
	,"PART_DIR5"
	,"PART_DIR6"
	,"PART_BUCKETS"
	,"DMGRSVC_ACCESS"
	,"SUCK_MAXLOG"
	,"DNEWS_TESTING"
	,"SPAM_NPOST_MAX"
	,"COMPRESS_DISABLE"
	,"POST_PROT_MSG"
	,"REBUILD_CANCEL"
	,"RAS_SLEEP"
	,"SENDBF_GROW"
	,"FIX_RE"
	,"PART_INDEX"
	,"TCP_RCVBF"
	,"SHOW_ALL_OUTPUT"
	,"REPORT_BUCKETS"
	,"DISKIO_MIN"
	,"SUCK_NOAUTH1"
	,"SUCK_NOAUTH2"
	,"RULES_DEBUG"
	,"LISTEN_PORTS"
	,"LIMIT_USERS"
	,"THREAD_IN"
	,"PART_FAST_BUGGY"
	,"THREAD_WRITE"
	,"FILTER_SILENT"
	,"SPAM_REPORT_BRIEF"
	,"THREAD_FIX"
	,"AUTH_FRIENDLY"
	,"NAKED_ALLOW"
	,"NAKED_REMOVE"
	,"TOMAIL_STRIP_BODY"
	,"PASS_NOLIMIT"
	,"CANCEL_VERIFY_HOST"
	,"PASS_TIMEOUT"
	,"UUCP_NOFLUSH"
	,"PGP_OPTIONS"
	,"TEST_NULLS"
	,"THREAD_FAKE"
	,"INPUT_WINDOW"
	,"THREAD_TIMEOUT"
	,"LISTEN_EXTRA"
	,"MASTER_ADDRESS"
	,"SPAWN_PROG"
	,"SPAM_AGE"
	,"GROUP_NEW"
	,"GETMAIL_CROSSPOSTS"
	,"STARTUP_DELAY"
	,"POST_ADD_GROUP"
	,"AUTH_SPAWN_LIMITS"
	,"USER_BLANK_OK"
	,"THREAD_TIMEOUT_WAIT"
	,"POST_PROT_PINE"
	,"INDEX_CHANGES"
	,"SPONSER_URL"
	,"SPONSER_DISABLE"
	,"SPONSER_ENABLE"
	,"CANCEL_RELEASE"
	,"XOVER_EXPIRE_NORMAL"
	,"SET_WORKINGSET"
	,"POST_ADD"
	,"HANGING_FAST"
	,"EXPIRE_LOST_BUCKETS"
	,"LOG_EVERYTHING"
	,"USE_CLOCK"
	,"USER_SLOW"
	,"READ_MID_OK"
	,"POST_CANCEL_AUTHORIZED"
	,"HIDE_VERSION"
	,"THREAD_REUSE"
	,"REAL_MAX"
	,"AUTHINFO_STRICT"
	,"DONT_DUP"
	,"SPAWN_FILTER_MAX"
	,"HEADER_NEWNUMBERS"
	,"DETECT_SUCK"
	,"TOMAIL_SUBJECT_ADD"
	,"AUTH_USERDOMAIN"
	,"AUTH_LOCAL_TOO"
	,"AUTH_POP_DOMAINS"
	,"SPONSER_NICER"
	,"POST_ADD_BLOCK"
	,"PIPE_USE"
	,"LIMIT_IP"
	,"WIDEAREA_HOST"
	,"WIDEAREA_MYNAME"
	,"POST_SPAWN"
	,"SPONSOR_DISABLE"
	,"SPAM_IGNORE_PARTS"
	,"WIDEAREA_MAX"
	,"HISTORY_PAGE_SIZE"
	,"FILTER_SYNC"
	,"DMGRCGI_ACCESS_STRICT"
	,"BUCKET_SORT_MAX"
	,"TOMAIL_ROUTE"
	,"POST_CANCEL_OWNER"
	,"FIX_PROTECTION_DISABLE"
	,"TELLNEWS_PASS_MASK"
	,"POISON_GROUP"
	,"POST_LOG_SIZE"
	,"ARTICLE_430"
	,"DEBUG_THOUT"
	,"AUTH_VIRTUAL_LOGIN"
	,"AUTH_MASK"
	,"TOMAIL_RUN"
	,"PRIORITY_BOOST"
	,"LIMIT_CONNECTOK"
	,"STRIP_POSTING_HOST_AUTH"
	,"RADIUS_VENDOR_ENCODED"
	,"RULES_LOCAL_ONLY"
	,"RADIUS_ACCT"
	,"POSTONLY_IHAVE"
	,"RADIUS_ACCT_PORT"
	,"AUTH_SKIP_CACHE"
	,"TOMAIL_URL"
	,"TOMAIL_PROJECT"
	,"GETMAIL_STRIP"
	,"ACCESS_POST_WARN"
	,"TOMAIL_WEB_LINK"
	,"SPAM_USER_NPOST_MAX"
	,"SET_DTABLE"
	,"XOVER_XHASH"
	,"TOMAIL_FROM_FORMAT"
	,"GETMAIL_FAIL_KEEPN"
	,"POST_STRIP"
	,"LOG_USERS"
	,"HIST_MAX"
	,"TOMAIL_REPLY_FORMAT"
	,"XTRACE_IPNAME"
	,"SUCK_NOFIX" 
	,"HIDE_KEY"
	,"GMT_FIX"
	,"INDEX_MIN"
	,"AUTH_TIMEOUT"
	,"DMULTI_SLAVE_ONLY"
	,"SMALL_FAST"
	,"SMALL_SPEED"
	,"IDX_WRITE_CACHE"
	,"IDX_WRITE_SIZE"
	,"TOMAIL_NNTP_LINK"
	,"PART_THREAD"
	,"PILE_NOPEN"
	,"FIXMOD_DISABLE"
	,"DFILTER_BINARY_LINES"
	,"SKIP_DUP"
	,"WIDEAREA_IPCHECK"
	,"WIDEAREA_TIMEOUT"
	,"SETPASS_DISABLE"
	,"PART_VANISH"
	,"PART_VANISH_MAX"
	,"TOMAIL_FROM_USER"
	,"POST_REC_NONEWSGROUPS"
	,"SLAVE_SAME"
	,"KILL_LOST_DISABLE"
	,"JUST_DIE"
	,"RADIUS_BIND_OUT"
	,"ACCESS_APPLYIP"
	,"SUCK_NOSKIP"
	,"CONTROL_STORE"
	,"PART_QUESIZE"
	,"GETMAIL_HEADER"
	,"POSTING_HOST_HIDE"
	,"AUTH_SPAWN_ADDIP"
	,NULL

};
#endif
#endif

