#include "dfeed.h"

/*
	SOCKET sk; 
	char *out;
	char *in;
	int inat;
	int outat,outlen;
	int type;
	int sending;
	int gothead;
	int keepalive;
	void (*fn_read)(struct CHAN *this); 
	void (*fn_write)(struct CHAN *this);
	void (*fn_close)(struct CHAN *this);
	struct CHAN *next;
	Head *head;

*/
static Chan *clist;
int chan_ingetc(Chan *c)
{
	int k;
	if (c->in==NULL) return 0;
	k =  c->in[c->inget];
	if (k!=0) c->inget++;
	return k;
}
Chan *chan_getlist(void)
{
	return clist;
}
void chan_setread(Chan *c, void (*fn_read)(struct CHAN *this, void *p1), void *p1)
{
	c->fn_read = fn_read;	
	c->p1 = p1;
}
void chan_setwrite(Chan *c, void (*fn_read)(struct CHAN *this, void *p1), void *p1)
{
	c->fn_write = fn_read;	
	c->p1 = p1;
}
void chan_setclose(Chan *c, void (*fn_read)(struct CHAN *this, void *p1), void *p1)
{
	c->fn_close = fn_read;	
	c->p1 = p1;
}
void chan_open(Chan *c, char *to, char *bind)
{
	char bf[BFSZ];
	char *s;
	int port=119;
	ncpy(bf,to,200);
	s = strchr(bf,':');
	if (s!=NULL) {
		*s = 0;
		port = atoi(s+1);
	}
	imsg("Open chan=%p (%s) port (%d) bind (%s) \n",c,to,port,bind);
	c->sk = tcp_openx(to,port,bind);
	c->iscompress = FALSE;
	if (c->sk==INVALID_SOCKET) {
		imsg("Open failed to (%s) (%s) \n",to,tcperror());
	} else {
		/* Experiment, remove if no improvement */
		tcp_setsndbf_raw(c->sk, 128000);
	}
}	

void chan_open_udp(Chan *c, char *to,  char *bind)
{
	char bf[BFSZ];
	char *s;
	int port=119;
	ncpy(bf,to,200);
	s = strchr(bf,':');
	if (s!=NULL) {
		*s = 0;
		port = atoi(s+1);
	}
	imsg("Open UDP chan=%p (%s) port (%d) bind (%s) \n",c,bf,port,bind);

	c->sk = tcp_create_udp(bind,0,bf,port);
	if (c->sk==INVALID_SOCKET) {
		imsg("Open failed to (%s) (%s) \n",bf,tcperror());
	}
	/*chan_write(c,"Hello, is anybody there\r\n",25);*/
}
#define COMPRESS_BUFFER_LENGTH 8192

static int initem;
int chan_setinitem(int t)
{
	initem = t;
	return TRUE;
}

#ifdef DOCOMPRESS
/*
	z_stream z_str;
+                 bzero(&z_str,sizeof(z_stream));
+                 deflateInit(&z_str,Z_DEFAULT_COMPRESSION);
deflateEnd(&z_str);
*/
static char CompressBuf[COMPRESS_BUFFER_LENGTH]; 

int chan_write_compress(Chan *c, char *ptr, int size)
{
	int i=0;
	int r;
	int chunk;
	int j;
	char *s;
	int iseol;

	stats_start(S_COMP);
	c->rawbytes+=size;

/*	initem = FALSE; */

	for (i=0; i<size; ) {
		chunk = size - i;
		if (chunk>7000) chunk = 7000;
		if (!initem) { /* Sending commands one line at a time  */
			s = ptr + i;
			for (j=0;j<chunk;j++,s++) {
				if (*s=='\n') {
					j++;
					chunk = j;
					break;
				}
			}
		} else {
			s = ptr + i + chunk - 1;
			for (j=chunk;j>0;j--,s--) {
				if (*s=='\n') {
					chunk = j;
					break;
				}
			}
		}
		if (chunk>7000) chunk = 7000;
		if (chunk<0) chunk = 1;

		c->z_str.next_in=ptr+i;
		c->z_str.avail_in=chunk;
		c->z_str.next_out=CompressBuf;
		c->z_str.avail_out=8192;
	
		deflate(&c->z_str,Z_SYNC_FLUSH);
		tcp_setblockraw(c->sk,TRUE);
		r = tcp_write(c->sk,CompressBuf,8192-c->z_str.avail_out);
		tcp_setblockraw(c->sk,FALSE);
		if (r<8192-c->z_str.avail_out) {
			emsg("bug in compressed send I think\n");
			goto failed;
		}
		if (r<0) goto failed;
		c->compressedbytes+=(8192-c->z_str.avail_out);
		i += chunk;
	}

	stats_end(S_COMP);
	return size;
failed:
	stats_end(S_COMP);
	imsg("Write failed (%s)\n",tcperror());
	chan_close(c);
	return -1;	
}

int chan_write_compress_good(Chan *c, char *ptr, int size)
{
	int i=0;
	int r;
	int chunk;

	stats_start(S_COMP);
	c->rawbytes+=size;
	for (i=0; i<size; ) {
		chunk = size - i;
		if (chunk>8000) chunk = 8000;
		c->z_str.next_in=ptr+i;
		c->z_str.avail_in=chunk;
		c->z_str.next_out=CompressBuf;
		c->z_str.avail_out=8192;
		deflate(&c->z_str,Z_SYNC_FLUSH);
		r = tcp_write(c->sk,CompressBuf,8192-c->z_str.avail_out);
		if (r<0) goto failed;				
		c->compressedbytes+=(8192-c->z_str.avail_out);
		i += chunk;
	}

	stats_end(S_COMP);
	return size;
failed:
	stats_end(S_COMP);
	imsg("Write failed (%s)\n",tcperror());
	chan_close(c);
	return -1;	
}
#endif
int chan_write(Chan *c, char *bf, int len)
{
	int r;
	if (c->sk==INVALID_SOCKET) return -1;

	stats_start(S_XWRITE);	
#ifdef DOCOMPRESS
	if (c->iscompress) {
		return chan_write_compress(c,bf,len);
	}
#endif
	errno = 0;
	r = tcp_write(c->sk,bf,len);
	if (r>0) dmsg_data(bf,r);
	stats_end(S_XWRITE);
	if (r<0) {
		imsg("Chan write %d bytes failed (%s)\n",len,tcperror());
		socket_close(c->sk); 
		c->sk = INVALID_SOCKET;
#ifdef DOCOMPRESS
		if (c->iscompress) {
			deflateEnd(&c->z_str);
			c->iscompress = FALSE;
		}
#endif
	}
	return r;
}
int chan_write_s(Chan *c, char *bf)
{
	return chan_write(c,bf,strlen(bf));
}
int chan_setdelay(Chan *c, int t)
{
	if (c->sk==INVALID_SOCKET) return FALSE;
	return tcp_setdelay(c->sk,t);
}
int chan_read(Chan *c, char *bf, int len)
{
	int r;
	if (c->sk==INVALID_SOCKET) return -1;
	r = tcp_read(c->sk,bf,len);
	if (r<0) {
		socket_close(c->sk); 
		c->sk = INVALID_SOCKET;
#ifdef DOCOMPRESS
		if (c->iscompress) {
			deflateEnd(&c->z_str);
			c->iscompress = FALSE;
		}
#endif
	}
	return r;
}
int chan_isopen(Chan *c)
{
	if (c->sk==INVALID_SOCKET) return FALSE;
	return TRUE;
}
/* brian */
int chan_isreallyopen(Chan *c)
{
        fd_set readfd,writefd,exceptfd;
	int nc;
	struct timeval timeout;

        timeout.tv_sec = 0;
        timeout.tv_usec = 0;
        FD_ZERO(&readfd);
        FD_ZERO(&writefd);
        FD_ZERO(&exceptfd);
	FD_SET(c->sk,&readfd);		
        nc = select(FD_SETSIZE,&readfd,&writefd,&exceptfd,&timeout);
	emsg("********** CHAN_ISREALLYOPEN nc:%d\n",nc);
	emsg("********** FD_ISSET(c->sk,&exceptfd) %d\n",FD_ISSET(c->sk,&exceptfd));
	if (nc>0) return TRUE;
	return FALSE;
}
void chan_instart(Chan *c)
{	
	c->inget = 0;
}
void chan_add(Chan *c)
{
	c->next = clist;
	clist = c;
}
void chan_idle(void)
{
	Chan *last=NULL;
	Chan *c,*next;

	for (c=clist;c!=NULL;c=next) {
		next = c->next;
		if ((c->sk==INVALID_SOCKET) && (c->canclose)) {
			imsg("Removing channel %p from list\n",c);
			if (last==NULL) clist = c->next;
			else last->next = c->next;
			if (c->in!=NULL) free(c->in);
			free(c);
		} else {
			last = c;	
		}
	}
	/* should free other structures if defined, e.g. head */	

	/* So it never gets called more often than it wants to be.*/	
	/* uses tcpwaitnext or nextwait I forget */
	udp_idle();


}
void chan_loop(void)
{
	chan_idle();
	dfeed_idle();
}
int chan_close(Chan *c)
{
	imsg("Closing chan %p\n",c);
	if (c->sk!=INVALID_SOCKET) socket_close(c->sk);
	c->sk = INVALID_SOCKET;
#ifdef DOCOMPRESS
	if (c->iscompress) {
		deflateEnd(&c->z_str);
		c->iscompress = FALSE;
	}
#endif
	return TRUE;
}
void chan_exit(void)
{
	Chan *c;
	for (c=clist;c!=NULL;c=c->next) {
		chan_close(c);
	}
	chan_idle();	
}
void chan_setcode(Chan *c, int r)
{
	c->code = r;
}
int chan_getcode(Chan *c)
{
	return c->code;
}
Chan *chan_new(void)
{
	Chan *c = malloc(sizeof(Chan));
	memset(c,0,sizeof(Chan));
	c->sk = INVALID_SOCKET;
	c->canclose = FALSE;
	c->next = clist;
	clist = c;
	return c;
}
int chan_init(void)
{
	tcp_startup();
	return TRUE;
}
void chan_setsending(Chan *c, int t)
{
	c->sending = t;
}
void chan_sethost(Chan *c, int h)
{
	c->hostid = h;
}
Chan *chan_findhost(int h)
{
	Chan *c;
	for (c=clist;c!=NULL;c=c->next) {
		if (c->hostid==h) return c;
	}
	return NULL;

}
void chan_run(void)
{
	int r;


	r = tcp_waitchans(clist);
}
void chan_listen_read(Chan *c)
{
}
void chan_release(Chan *c)
{
	c->canclose = TRUE;
}